%
% Algorithm.m
%
classdef (Abstract) Algorithm < handle
  
  properties (GetAccess = protected, SetAccess = private)
    stateKGenStrategy
    obsKGenStrategy
    mcdcStrategy
  end

  methods (Access = protected)

    function this = Algorithm(kernelGeneratorStrategy, mcdcStrategy)
      this.stateKGenStrategy = kernelGeneratorStrategy(this, 1);
      this.obsKGenStrategy = kernelGeneratorStrategy(this, 2);
      this.mcdcStrategy = mcdcStrategy(this);
    end

  end

  methods (Abstract, Access = public)

    Execute(this, in, out, aspect)

  end
  
end
