%
% MCDCStrategy.m
%

classdef (Abstract) MCDCStrategy < handle

  properties (Access = protected)
    algorithm
    prevGramMatState
    prevGramMatObs
    gridData
    initialStateMean
    initialObsMean
    particleFilter
  end

  methods (Access = protected)

    function this = MCDCStrategy(algorithm)
      this.algorithm = algorithm;
    end

  end

  methods (Abstract, Access = public)

    StateMean(this, j, in, out)

    ObsMean(this, j, in, out)

    StateSigma(this, j, gramMatrix)

    ObsSigma(this, j, gramMatrix)

    AcceptanceLogProbability(this, j, in, out, logLikelihood, stateVals, obsVals, gramMatState, gramMatObs)

  end

  methods (Access = public)

    function result = GetParticleFilter(this)
      result = this.particleFilter;
    end

    function SetGridData(this, gridData)
      this.gridData = gridData;
    end

    function SaveGramMatrices(this, gramMatState, gramMatObs)
      this.prevGramMatState = gramMatState;
      this.prevGramMatObs   = gramMatObs;
    end

  end

end
