%
% MCDCTest.m
%

function [result, FnState, FnObs] = MCDCTest(u, y, N, varargin)

  mcdcMatFile = varargin{1};

  [algorithm, in, out] = MCDCMatFile.Load(mcdcMatFile);

  gridData = GridData(in.xGrids);

  n = size(out.loglik, 1);
  for i = 1:n
    j = find(out.IDX == i);
    f{i} = VectorValuedFunction(ModelFunctions2(in.splineHandle, gridData, out.FVAt(min(j))));
    g{i} = VectorValuedFunction(ModelFunctions2(in.splineHandle, gridData, out.GVAt(min(j))));
    w(i) = size(j, 1);
  end

  FnState = @(x) AverageFun(f, w, x);
  FnObs   = @(x) AverageFun(g, w, x);

  q = 1;
  r = 0.1;

  result = ParticleFilter(in.x0, in.xaux', u', y', FnState, FnObs, q, r, N, in.K);

end

function result = AverageFun(handles, weights, x)
  n = size(handles, 2);
  result = handles{1}(x) .* weights(1);
  for i = 2:n
    result = result + handles{i}(x) .* weights(i);
  end
  result = result ./ sum(weights);
end
