%
% RBFKernel.m
%
classdef RBFKernel < Kernel
  
  properties (SetAccess = private)
    Sigma
    L
  end
  
  methods (Access = public)
  
    function this = RBFKernel(sigma, l)
      this.Sigma = sigma;
      this.L = l;
    end
    
    function result = Properties(this)
      result = [this.Sigma; this.L];
    end
    
    function result = CreateGramMatrix(this, xGrid)
      l = size(xGrid, 2);
      s = eye(size(xGrid, 1)) * this.L; % SIGMA?
      xGridT = xGrid';
      result = this.Sigma ^ 2 * cell2mat(arrayfun(@(i) (mvnpdf(xGridT, xGridT(i,:), s)), 1:l, 'UniformOutput', false));
    end
    
    function result = ToString(this)
      result = sprintf('[ Sigma=%f, L=%f ]', this.Sigma, this.L);
    end
    
  end
  
end
