%
% RBFKernelGeneratorStrategyChoice2.m
%

classdef RBFKernelGeneratorStrategyChoice2 < RBFKernelGeneratorStrategy

  properties (Access = private)
    kind
  end

  methods (Access = public)

    function this = RBFKernelGeneratorStrategyChoice2(algorithm, kind)
      this = this@RBFKernelGeneratorStrategy(algorithm);
      this.kind = kind;
    end

    function result = GetGenerator(this, j, in, out)
      if j == 1
        result = this.initial;
      else
        dim = size(this.initial, 2);
        for i = 1:dim
          if this.kind == 1
            prevParams = out.SKPAt(j - 1);
          else
            prevParams = out.OKPAt(j - 1);
          end
          sDist = this.GetDistribution(prevParams(1, i, 1), 1, this.initial{i}.SDistribution);
          lDist = this.GetDistribution(prevParams(1, i, 2), 1, this.initial{i}.LDistribution);
          result{i} = RBFKernelGenerator(sDist, lDist);
        end
      end
    end

  end

  methods (Access = private)

    function result = GetDistribution(this, mu, sigma, uniformDist)
      result = BoundedNormalDistribution(mu, sigma, uniformDist.LowerBound, uniformDist.UpperBound);
    end

  end

end

