xGrids = { ...
  [-1:0.2:1], ...
  [-1:0.2:1], ...
  [-1:0.2:1] ...
};

stateKernelGens = { ...
  RBFKernelGenerator(UniformDistribution(0.01, 10), UniformDistribution(0.01, 10)), ...
  RBFKernelGenerator(UniformDistribution(0.01, 10), UniformDistribution(0.01, 10)), ...
  RBFKernelGenerator(UniformDistribution(0.01, 10), UniformDistribution(0.01, 10)) ...
};

obsKernelGens = { ...
  RBFKernelGenerator(UniformDistribution(0.01, 10), UniformDistribution(0.01, 10)), ...
  RBFKernelGenerator(UniformDistribution(0.01, 10), UniformDistribution(0.01, 10)) ...
};

stateMeanFuncs = { ...
  @(x) (repmat(0, 1, size(x, 2))), ...
  @(x) (repmat(0, 1, size(x, 2))), ...
  @(x) (repmat(0, 1, size(x, 2))) ...
};

obsMeanFuncs = { ...
  @(x) (repmat(0, 1, size(x, 2))), ...
  @(x) (repmat(0, 1, size(x, 2))) ...
};

splineHandle = @GenericSpline;

x0 = [0 0 0];
z = [1 2 3 4 5 6 7 8 9 10; 0 0 0 0 0 0 0 0 0 0];
N = 5000;
J = 1000;

aspect = Aspect();
aspect.LogFileName = 'test.log';
aspect.MatFileNamePrefix = 'test';
aspect.SavesIntermediateMat = true;

MCDCTrain(PMMH(), xGrids, stateKernelGens, obsKernelGens, stateMeanFuncs, obsMeanFuncs, splineHandle, x0, z, N, J, aspect);
