%
% Spline.m
%

classdef Spline < handle

  methods(Static)

    function result = Cubic(x, y)
      f = spline(x, [0 y 0]);
      result = @(xx) (ppval(f, xx));
    end

    function result = B0(x, y)
      result = Spline.Bn(x, y, 0);
    end

    function result = B1(x, y)
      result = Spline.Bn(x, y, 1);
    end

    function result = B3(x, y)
      result = Spline.Bn(x, y, 3);
    end

    function result = Bn(x, y, d)
      l = length(x);
      f = spmak([repmat(x(1), 1, d) x repmat(x(l), 1, d + 1)], y);
      result = @(xx) (spval(f, xx));
    end

  end

end
